// Output generated from file: D:/fragmentarium/out-18_Files/Menger45b1.frag
// Created: Sun Dec 4 11:00:57 2016
// Output generated from file: D:/fragmentarium/Menger45_a1.frag
// Created: Sat Nov 26 17:54:52 2016
#info Mandelbox Distance Estimator (Rrrola's version).
#define providesInit
#include "DE-Raytracer.frag"
#include "MathUtils.frag"
#group Menger45
//Menger45 - no trig
//based on code by Trafassel// Gestaltlupe 3.4
//http://www.fractalforums.com/ifs-iterated-function-systems/menger-sponge-45-rotation/msg97840/#new
/*
The distance estimator below was originalled devised by Buddhi.
This optimized version was created by Rrrola (Jan Kadlec), http://rrrola.wz.cz/

See this thread for more info: http://www.fractalforums.com/3d-fractal-generation/a-mandelbox-distance-estimate-formula/15/
*/
const float sin45  = 0.707106781186547524;
uniform int Bailout;  slider[0,20,20]
uniform int Iterations;  slider[0,60,300]
uniform int ColorIterations;  slider[0,3,300]

// Iteration weight parameters
uniform bool iterW; checkbox[false]
uniform float ScaleW;  slider[0.0,1.0,3.0]
uniform float OffsetW1;  slider[-5.0,0.0,5.0]
uniform float OffsetW2;  slider[-5.0,0.0,5.0]
uniform int intA;  slider[0,0,60]
uniform int intB;  slider[0,0,60]

// Menger Sponge
uniform vec3 PreAddM; slider[(-5.0,-5.0,-5.0),(0.0,0.0,0.0),(5.0,5.0,5.0)]
uniform vec3 OffsetM; slider[(-5.0,-5.0,-5.0),(2.0,2.0,2.0),(5.0,5.0,5.0)]
/*uniform vec3 OffsetTemp; slider[(-5.0,-5.0,-5.0),(2.0,2.0,2.0),(5.0,5.0,5.0)]*/
uniform float ScaleM;  slider[-5.0,3.0,5.0]
uniform bool EnableConditionalZ; checkbox[false]

// temp mathsoooooooooooooooooo
	//vec3 OffsetM = 0.0;
	//OffsetM = offsetTemp *(ScaleM -1.0);


// rot45 xy plane
uniform int StartR45;  slider[0,0,60]
uniform int StopR45;  slider[0,0,60]


// precomputed constants

uniform vec3 RotVector; slider[(0,0,0),(1,1,1),(1,1,1)] 
uniform float RotAngle; slider[0.00,0,180]
mat3 rot;

void init() {
	 rot = rotationMatrix3(normalize(RotVector), RotAngle);
}




float absScalem1 = abs(ScaleM - 1.0);
float AbsScaleRaisedTo1mIters = pow(abs(ScaleM), float(1-Iterations));


float DE(vec3 pos)
{
	float Dd = 1.0;	
	vec3 z = pos;
	int i = 0;
	float r2;	

	for (int i=0; i<Iterations; i++)
  {
		z = abs(z + PreAddM);
		// Bailout Condition:  note not a dot(z,z) bailout
		//if (z.x > BailoutM) return false;// break??
		//if (z.y > BailoutM) return false;
		//if (z.z > BailoutM) return false;

		//Condtional swizzle
		if (z.x < z.y ) z.xy = z.yx;
		if (z.x < z.z ) z.xz = z.zx;
		if (z.y < z.z ) z.yz = z.zy;

		z *= rot;
	
		// Scale & Offset   x = scale*x - offsetX*(scale-1);	
		//offsetX*(scale-1) = Offset45
		z *= ScaleM;
		Dd *= ScaleM; // * Tweak
		z.x -= OffsetM.x;
		z.y -= OffsetM.y;
		//z.z = z.z * ScaleM - OffsetM.z;
		//z = z * ScaleM - OffsetM;

		// on reverts to standard Menger Sponge 
		if (EnableConditionalZ) 
		{
			if (z.z > 1.0) z.z -= OffsetM.z;
		}
		else
		{
			z.z -= OffsetM.z;
		}
			// Rotate x,y plane by 45 degree:
		if ( i >= StartR45 && i < StopR45)
		{   
		float xtemp = sin45 * ( z.x - z.y );
		z.y = sin45 * ( z.y + z.x );
		z.x = xtemp;
		}	
		r2 = dot(z,z);
		if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z,r2)));	

    if ( r2>Bailout)	
		{
		float r = sqrt(r2);
		//return (r) / Dd;
		return (r - absScalem1) / Dd - AbsScaleRaisedTo1mIters;
		}
	}
}














#preset Default
FOV = 0.4
Eye = 0,-9.7,0
Target = 0,-1.7,0
Up = 1,0,0
EquiRectangular = false
AutoFocus = false
FocalPlane = 1
Aperture = 0
Gamma = 2
ToneMapping = 4
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Detail = -2.684588
DetailAO = -1.009242
FudgeFactor = 1
Dither = 0.5
NormalBackStep = 1
AO = 0,0,0,0.7
Specular = 0.4
SpecularExp = 16
SpecularMax = 10
SpotLight = 1,1,1,0.4
SpotLightDir = 0.1,0.1
CamLight = 1,1,1,1
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
HardShadow = 0
ShadowSoft = 2
Reflection = 0
DebugSun = false
BaseColor = 0.6666667,0,0
OrbitStrength = 0.3416988
X = 0.5,0.6,0.6,0.3345455
Y = 1,0.6,0,-0.4459459
Z = 0.8,0.78,1,0.8039927
R = 0.4,0.7,1,0.12
BackgroundColor = 0.6,0.6,0.45
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,1
FloorHeight = 0
FloorColor = 1,1,1
MaxRaySteps = 80
Bailout = 6
Iterations = 24
ColorIterations = 2
iterW = false
ScaleW = 1
OffsetW1 = 0
OffsetW2 = 0
intA = 0
intB = 0
PreAddM = 0,0,0
OffsetM = 2,2,1
ScaleM = 2
EnableConditionalZ = false
StartR45 = 1
StopR45 = 7
RotVector = 1,1,1
RotAngle = 45
#endpreset

